'''
Created on Aug 19, 2011

@author: maemo
'''

from optparse import OptionParser
 
import dbus
import gst
import sys
import time
import pygame
 
class Player(object):
 
    mic = None
 
    def __init__(self):
        """
        @summary: The Constructor class, that searches for the microphone on initialization
        """
        
        """
        @summary: The Constructor class
        """
        pygame.mixer.quit()
        pygame.mixer.init()
        pygame.init()
        
        bus = dbus.SystemBus()
        hal_manager = bus.get_object("org.freedesktop.Hal",
                                     "/org/freedesktop/Hal/Manager")
        hal_manager = dbus.Interface(hal_manager, "org.freedesktop.Hal.Manager")
 
        print hal_manager
        devices = hal_manager.FindDeviceStringMatch("alsa.type", "capture")
 
        identifiers = []
 
        for dev in devices:
            device = bus.get_object("org.freedesktop.Hal", dev)
 
            card = device.GetAllProperties(dbus_interface="org.freedesktop.Hal.Device")
            if card["alsa.card"] not in identifiers:
                print "%d. %s" % (card["alsa.card"], card["alsa.card_id"])
                identifiers.append(card["alsa.card"])
 
        self.mic = identifiers[0]
 
 
    def record(self, destination):
        """
        @summary: Records the audio with the microphone and saves to the given destination
        @param destination: The destination where to save the captured voice
        @type destination: String
        """
 
        pipeline = gst.parse_launch("""alsasrc device=hw:%d ! audioconvert ! level name=recordlevel interval=10000000 ! audioconvert ! flacenc ! filesink location=%s""" % (self.mic, destination))
        pipeline.set_state(gst.STATE_PLAYING)
 
        print "recording, press enter to stop"
        sys.stdin.readline()
 
        pipeline.set_state(gst.STATE_NULL)
        time.sleep(5)
        
    def Play(self, sound):
        """
        @summary: This function is used to play the given sound
        @param sound: The sound to be played
        @type sound: pygame sound object 
        """
        sound.play()
 
    def Load(self, filename):
        """
        @summary: This function loads the given filename into a pygame
                  readable sound object
        @param filename: The path to the file to be loaded
        @type filename: String
        @return: Loaded pygame music object
        @rtype: pygame Sound
        """
 
        return pygame.mixer.Sound(filename)