'''
Created on Aug 18, 2011

@author: maemo
'''
from optparse import OptionParser
 
import dbus
import gst
import sys
import time
 
class SoundRecorder(object):
    """
    @summary: This is the SoundRecorder class that handles locating the microphone
              and capturing voice from the mic. Currently uses somewhat "dirty" method of
              calling gstreamer via command line, but works pretty well nonetheless :-D
    """
 
    mic = None
 
    def __init__(self):
        """
        @summary: The Constructor class, that searches for the microphone on initialization
        """
        bus = dbus.SystemBus()
        hal_manager = bus.get_object("org.freedesktop.Hal",
                                     "/org/freedesktop/Hal/Manager")
        hal_manager = dbus.Interface(hal_manager, "org.freedesktop.Hal.Manager")
 
        print hal_manager
        devices = hal_manager.FindDeviceStringMatch("alsa.type", "capture")
 
        identifiers = []
 
        for dev in devices:
            device = bus.get_object("org.freedesktop.Hal", dev)
 
            card = device.GetAllProperties(dbus_interface="org.freedesktop.Hal.Device")
            if card["alsa.card"] not in identifiers:
                print "%d. %s" % (card["alsa.card"], card["alsa.card_id"])
                identifiers.append(card["alsa.card"])
 
        self.mic = identifiers[0]
 
 
    def Record(self, destination):
        """
        @summary: Records the audio with the microphone and saves to the given destination
        @param destination: The destination where to save the captured voice
        @type destination: String
        """
 
        pipeline = gst.parse_launch("""alsasrc device=hw:%d ! audioconvert ! level name=recordlevel interval=10000000 ! audioconvert ! flacenc ! filesink location=%s""" % (self.mic, destination))
        pipeline.set_state(gst.STATE_PLAYING)
 
        print "recording, press enter to stop"
        sys.stdin.readline()
 
        pipeline.set_state(gst.STATE_NULL)
        time.sleep(5)
 
if __name__ == "__main__":
    # This is used if the code is run straight from the command line
    recorder = SoundRecorder()
    recorder.Record("output.wav")