'''
Created on Aug 18, 2011

@author: maemo
'''

import pygtk; pygtk.require('2.0')
import gtk
import dbus
import time
import urllib
import webbrowser
import osso
import hildon
from Player import Player


def octify(str):
        '''     
        Returns a list of octet bytes representing
        each char of the input str.               
        '''                                       
 
        bytes = map(ord, str)
        bitsconsumed = 0     
        referencebit = 7     
        octets = []          
 
        while len(bytes):
                byte = bytes.pop(0)
                byte = byte >> bitsconsumed
 
                try:                       
                        nextbyte = bytes[0]
                        bitstocopy = (nextbyte & (0xff >> referencebit)) << referencebit
                        octet = (byte | bitstocopy)                                     
 
                except:
                        octet = (byte | 0x00)
 
                if bitsconsumed != 7:
                        octets.append(byte | bitstocopy)
                        bitsconsumed += 1               
                        referencebit -= 1               
                else:                                   
                        bitsconsumed = 0                
                        referencebit = 7                
 
        return octets
 
def semi_octify(str):
        '''          
        Expects a string containing two digits.
        Returns an octet -                     
        first nibble in the octect is the first
        digit and the second nibble represents 
        the second digit.                      
        '''                                    
        try:                                   
                digit_1 = int(str[0])          
                digit_2 = int(str[1])          
                octet = (digit_2 << 4) | digit_1
        except:                                 
                octet = (1 << 4) | digit_1      
 
        return octet
 
 
def deoctify(arr):
 
        referencebit = 1
        doctect = []    
        bnext = 0x00    
 
        for i in arr:
 
                bcurr = ((i & (0xff >> referencebit)) << referencebit) >> 1
                bcurr = bcurr | bnext                                      
 
                if referencebit != 7:
                        doctect.append( bcurr )
                        bnext = (i & (0xff << (8 - referencebit)) ) >> 8 - referencebit
                        referencebit += 1                                              
                else:                                                                  
                        doctect.append( bcurr )                                        
                        bnext = (i & (0xff << (8 - referencebit)) ) >> 8 - referencebit
                        doctect.append( bnext )                                        
                        bnext = 0x00                                                   
                        referencebit = 1                                               
 
        return ''.join([chr(i) for i in doctect])
 
 
def createPDUmessage(number, msg):
        '''                       
        Returns a list of bytes to represent a valid PDU message
        '''                                                     
        numlength = len(number)                                 
        if (numlength % 2) == 0:                                
                rangelength = numlength                         
        else:                                                   
                number = number + 'F'                           
                rangelength = len(number)                       
 
        octifiednumber = [ semi_octify(number[i:i+2]) for i in range(0,rangelength,2) ]
        octifiedmsg = octify(msg)                                                      
        HEADER = 1                                                                     
        FIRSTOCTETOFSMSDELIVERMSG = 10                                                 
        ADDR_TYPE = 129 #unknown format                                                
        number_length = len(number)                                                    
        msg_length = len(msg)                                                          
        pdu_message = [HEADER, FIRSTOCTETOFSMSDELIVERMSG, number_length, ADDR_TYPE]    
        pdu_message.extend(octifiednumber)                                             
        pdu_message.append(0)                                                          
        pdu_message.append(0)                                                          
        pdu_message.append(msg_length)                                                 
        pdu_message.extend(octifiedmsg)                                                
        return pdu_message 


class Easy_Contact(object):

    def __init__(self, img, phoneNum):
        
        self.img = img
        self.phoneNum = phoneNum
        self.bus = dbus.SystemBus()
        self.csd_call = dbus.Interface(self.bus.get_object("com.nokia.csd",
                                                      "/com/nokia/csd/call"),
                                                      "com.nokia.csd.Call")
        
        self.smsobject = self.bus.get_object('com.nokia.phone.SMS', '/com/nokia/phone/SMS/ba212ae1')
        self.smsiface = dbus.Interface(self.smsobject, 'com.nokia.csd.SMS.Outgoing')
        
        self.callStatus = dbus.Interface(self.bus.get_object("com.nokia.csd",
                                                      "/com/nokia/csd/call/1"),
                                                      "com.nokia.csd.Call.Instance.GetStatus")
        
        self.mail = dbus.Interface(self.bus.get_object("com.nokia.modest",
                                            "/com/nokia/modest"),
                                            "com.nokia.modest")
       
        self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.window.connect("delete_event", self.delete_event)
        self.window.connect("destroy", self.destroy)
        self.window.set_border_width(10)
        
        
        self.button1 = hildon.Button(gtk.HILDON_SIZE_AUTO, hildon.BUTTON_ARRANGEMENT_VERTICAL, "")
        self.button1.connect("clicked", self.pressButton, None)
        self.button1.connect_object("clicked", gtk.Widget.destroy, self.window)
        
        self.button2 = hildon.Button(gtk.HILDON_SIZE_AUTO, hildon.BUTTON_ARRANGEMENT_VERTICAL, "")
        self.button2.connect("clicked", self.place_email, None)
        self.button2.connect_object("clicked", gtk.Widget.destroy, self.window)
    
        
        image = gtk.image_new_from_file(self.img)
        # and then to set it to the button
        self.button1.set_image(image)
     
        image2 = gtk.image_new_from_file("email")
        # and then to set it to the button
        self.button2.set_image(image2)
        
        self.buttonBox = gtk.HButtonBox()
        self.buttonBox.set_layout(gtk.BUTTONBOX_SPREAD)
 

        #buttonBox.add(email)
        self.buttonBox.add(self.button1)
        self.buttonBox.add(self.button2)
        #buttonBox.add(button3)
         # And then the buttonBox to the window
        self.window.add(self.buttonBox)
    
        self.window.show_all()

              
    def pressButton(self, widget, data=None):
        print "Pressed"
        
        self.Call(self.phoneNum)
         

        self.check_call();
      
        #player = Player()
        #Player().record("output.wav")
        
        
    def delete_event(self, widget, event, data=None):
        print "delete event occured"

        return False

    def destroy(self, widget, data=None):
        gtk.main_quit()

    def Call(self, number):
        """ 
        @summary: The function to Call to a given number 
        @param number: The number to call to
        @type number: String
        """
        self.csd_call.CreateWith(str(number), dbus.UInt32(0))
        
    def Send(self, message, number):
        """ 
        @summary: The Send function, that actually sends the given message
        @param message: The message to be sent
        @type message: String
        @param number: The number to send the message to (can be with country code also)
        @type number: String
        """
        arr = dbus.Array(createPDUmessage(number.replace('+', '00'), message))
        msg = dbus.Array([arr])
        self.smsiface.Send(msg, '')
    
    def check_call(self):
      bus = dbus.SystemBus()
      callobject = bus.get_object('com.nokia.csd.Call', '/com/nokia/csd/call/1')
      smsiface = dbus.Interface(callobject, 'com.nokia.csd.Call.Instance')
      print "call status1: " + str(smsiface.GetStatus())
      start_time = time.clock()
      while smsiface.GetStatus() == 1 or smsiface.GetStatus() == 3 or smsiface.GetStatus() == 4 or smsiface.GetStatus() == 6:
         second_time = time.clock() - start_time 
         print second_time
         print "call status2: " + str(smsiface.GetStatus())
         if second_time >= 2.00:
             self.Send("Hello, contact me please", self.phoneNum)
             self.csd_call.Release();
             player = Player()
             # Load the soundfile with the player
             sound = player.Load("vvv")
             # Play the file
             player.Play(sound)
             break
      
     
    def place_email(self ,widget, data=None):
       
        bus = dbus.SystemBus()
        mail = dbus.Interface(bus.get_object('com.nokia.modest',
                                           '/com/nokia/modest'),
                                           'com.nokia.modest')
        mail.MailTo("mailto:smehrouzi@gmail.com?subject=myreport&body=Hello, contact me please")
        
     
class Start_View(object):

    def __init__(self):
           
        self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.window.connect("delete_event", self.delete_event)
        self.window.connect("destroy", self.destroy)
        self.window.set_border_width(10)
        
        
         # Create three different buttons as an Image
        button1 = hildon.Button(gtk.HILDON_SIZE_AUTO, hildon.BUTTON_ARRANGEMENT_VERTICAL, "")
        button2 = hildon.Button(gtk.HILDON_SIZE_AUTO, hildon.BUTTON_ARRANGEMENT_VERTICAL, "")
        button3 = hildon.Button(gtk.HILDON_SIZE_AUTO, hildon.BUTTON_ARRANGEMENT_VERTICAL, "")
     
        # When the button is given the "clicked" signal, we ask it to call the
        # hello () function as defined above. If the data passed to the callback
        # function is None and is ignored in the callback function.
        button1.connect("clicked", self.createEC,("girl1.jpg","0505883145"))
        button2.connect("clicked", self.createEC,("girl2.jpg","0505883145"))
        button3.connect("clicked", self.createEC,("boy1.jpg","0505883145"))
     
        # Set the button to have an image
        # First we need to load the image from file
        image1 = gtk.image_new_from_file("girl1_icon.jpg")
        image2 = gtk.image_new_from_file("girl2_icon.jpg")
        image3 = gtk.image_new_from_file("boy1_icon.jpg")
        # and then to set it to the button
        button1.set_image(image1)
        button2.set_image(image2)
        button3.set_image(image3)
     
        # Now we create a button box, which is an container that can have multiple buttons in it
        # The one used here is Vertical box, that places the buttons on top of each other, but
        # you could create HButtonBox() that is a horizontal box, that puts buttons next to
        # each other
        buttonBox = gtk.HButtonBox()
     
        # Here the layourtis defined to spread the buttons evenly, options to use here are
        # gtk.BUTTONBOX_SPREAD, gtk.BUTTONBOX_EDGE, gtk.BUTTONBOX_START and gtk.BUTTONBOX_END
        buttonBox.set_layout(gtk.BUTTONBOX_SPREAD)
     
        # And then finally add all the buttons to the buttonBox
        buttonBox.add(button1)
        buttonBox.add(button2)
        buttonBox.add(button3)
        # And then the buttonBox to the window
        self.window.add(buttonBox)
     
     
     
        # The final step is to display this newly created widget and all widgets it
        # contains.
        self.window.show_all()
     
        # All GTK+ applications must have a gtk_main(). Control ends here and waits
        # for an event to occur (like a key press or mouse event).
        gtk.main()
  
    def delete_event(self, widget, event, data=None):
        print "delete event occured"
        return False

    def destroy(self, widget, data=None):
        gtk.main_quit()
   
    def createEC(self,widget,data):
        easy_contact = Easy_Contact(data[0],data[1])
        
   
def run():
    start_app = Start_View()

if __name__ == '__main__':
    run()
